searchData={"items":[{"type":"module","title":"Calendarific","doc":"Documentation for `Calendarific`.","ref":"Calendarific.html"},{"type":"function","title":"Calendarific.holidays/1","doc":"Fetches holidays for a given country and year.","ref":"Calendarific.html#holidays/1"},{"type":"function","title":"Examples - Calendarific.holidays/1","doc":"iex> Calendarific.holidays(country: \"US\", year: 2021)\n    [\n      %Calendarific.Types.Holiday{\n        country: %Calendarific.Types.Country{id: \"us\", name: \"United States\"},\n        date: %Calendarific.Types.Date{\n          datetime: %Calendarific.Types.DateTime{day: 1, month: 1, year: 2021},\n          iso: \"2021-01-01\"\n        },\n        description: \"New Year's Day is the first day of the Gregorian calendar, which is widely used in many countries such as the USA.\",\n        locations: \"All\",\n        name: \"New Year's Day\",\n        states: \"All\",\n        type: [\"National holiday\"]\n      }\n      ...\n    ]","ref":"Calendarific.html#holidays/1-examples"},{"type":"module","title":"Calendarific.Apis.Holidays","doc":"","ref":"Calendarific.Apis.Holidays.html"},{"type":"function","title":"Calendarific.Apis.Holidays.fetch/1","doc":"","ref":"Calendarific.Apis.Holidays.html#fetch/1"},{"type":"module","title":"Calendarific.HttpClient","doc":"","ref":"Calendarific.HttpClient.html"},{"type":"function","title":"Calendarific.HttpClient.delete/3","doc":"Issues a DELETE request to the given url.\n\nReturns `{:ok, response}` if the request is successful, `{:error, reason}`\notherwise.\n\nSee `request/5` for more detailed information.","ref":"Calendarific.HttpClient.html#delete/3"},{"type":"function","title":"Calendarific.HttpClient.delete!/3","doc":"Issues a DELETE request to the given url, raising an exception in case of\nfailure.\n\nIf the request does not fail, the response is returned.\n\nSee `request!/5` for more detailed information.","ref":"Calendarific.HttpClient.html#delete!/3"},{"type":"function","title":"Calendarific.HttpClient.get/3","doc":"Issues a GET request to the given url.\n\nReturns `{:ok, response}` if the request is successful, `{:error, reason}`\notherwise.\n\nSee `request/5` for more detailed information.","ref":"Calendarific.HttpClient.html#get/3"},{"type":"function","title":"Calendarific.HttpClient.get!/3","doc":"Issues a GET request to the given url, raising an exception in case of\nfailure.\n\nIf the request does not fail, the response is returned.\n\nSee `request!/5` for more detailed information.","ref":"Calendarific.HttpClient.html#get!/3"},{"type":"function","title":"Calendarific.HttpClient.head/3","doc":"Issues a HEAD request to the given url.\n\nReturns `{:ok, response}` if the request is successful, `{:error, reason}`\notherwise.\n\nSee `request/5` for more detailed information.","ref":"Calendarific.HttpClient.html#head/3"},{"type":"function","title":"Calendarific.HttpClient.head!/3","doc":"Issues a HEAD request to the given url, raising an exception in case of\nfailure.\n\nIf the request does not fail, the response is returned.\n\nSee `request!/5` for more detailed information.","ref":"Calendarific.HttpClient.html#head!/3"},{"type":"function","title":"Calendarific.HttpClient.options/3","doc":"Issues an OPTIONS request to the given url.\n\nReturns `{:ok, response}` if the request is successful, `{:error, reason}`\notherwise.\n\nSee `request/5` for more detailed information.","ref":"Calendarific.HttpClient.html#options/3"},{"type":"function","title":"Calendarific.HttpClient.options!/3","doc":"Issues a OPTIONS request to the given url, raising an exception in case of\nfailure.\n\nIf the request does not fail, the response is returned.\n\nSee `request!/5` for more detailed information.","ref":"Calendarific.HttpClient.html#options!/3"},{"type":"function","title":"Calendarific.HttpClient.patch/4","doc":"Issues a PATCH request to the given url.\n\nReturns `{:ok, response}` if the request is successful, `{:error, reason}`\notherwise.\n\nSee `request/5` for more detailed information.","ref":"Calendarific.HttpClient.html#patch/4"},{"type":"function","title":"Calendarific.HttpClient.patch!/4","doc":"Issues a PATCH request to the given url, raising an exception in case of\nfailure.\n\nIf the request does not fail, the response is returned.\n\nSee `request!/5` for more detailed information.","ref":"Calendarific.HttpClient.html#patch!/4"},{"type":"function","title":"Calendarific.HttpClient.post/4","doc":"Issues a POST request to the given url.\n\nReturns `{:ok, response}` if the request is successful, `{:error, reason}`\notherwise.\n\nSee `request/5` for more detailed information.","ref":"Calendarific.HttpClient.html#post/4"},{"type":"function","title":"Calendarific.HttpClient.post!/4","doc":"Issues a POST request to the given url, raising an exception in case of\nfailure.\n\nIf the request does not fail, the response is returned.\n\nSee `request!/5` for more detailed information.","ref":"Calendarific.HttpClient.html#post!/4"},{"type":"function","title":"Calendarific.HttpClient.process_headers/1","doc":"","ref":"Calendarific.HttpClient.html#process_headers/1"},{"type":"function","title":"Calendarific.HttpClient.process_request_body/1","doc":"","ref":"Calendarific.HttpClient.html#process_request_body/1"},{"type":"function","title":"Calendarific.HttpClient.process_request_headers/1","doc":"","ref":"Calendarific.HttpClient.html#process_request_headers/1"},{"type":"function","title":"Calendarific.HttpClient.process_request_options/1","doc":"","ref":"Calendarific.HttpClient.html#process_request_options/1"},{"type":"function","title":"Calendarific.HttpClient.process_request_params/1","doc":"","ref":"Calendarific.HttpClient.html#process_request_params/1"},{"type":"function","title":"Calendarific.HttpClient.process_request_url/1","doc":"","ref":"Calendarific.HttpClient.html#process_request_url/1"},{"type":"function","title":"Calendarific.HttpClient.process_response/1","doc":"","ref":"Calendarific.HttpClient.html#process_response/1"},{"type":"function","title":"Calendarific.HttpClient.process_response_body/1","doc":"","ref":"Calendarific.HttpClient.html#process_response_body/1"},{"type":"function","title":"Calendarific.HttpClient.process_response_chunk/1","doc":"","ref":"Calendarific.HttpClient.html#process_response_chunk/1"},{"type":"function","title":"Calendarific.HttpClient.process_response_headers/1","doc":"","ref":"Calendarific.HttpClient.html#process_response_headers/1"},{"type":"function","title":"Calendarific.HttpClient.process_response_status_code/1","doc":"","ref":"Calendarific.HttpClient.html#process_response_status_code/1"},{"type":"function","title":"Calendarific.HttpClient.process_status_code/1","doc":"","ref":"Calendarific.HttpClient.html#process_status_code/1"},{"type":"function","title":"Calendarific.HttpClient.process_url/1","doc":"","ref":"Calendarific.HttpClient.html#process_url/1"},{"type":"function","title":"Calendarific.HttpClient.put/4","doc":"Issues a PUT request to the given url.\n\nReturns `{:ok, response}` if the request is successful, `{:error, reason}`\notherwise.\n\nSee `request/5` for more detailed information.","ref":"Calendarific.HttpClient.html#put/4"},{"type":"function","title":"Calendarific.HttpClient.put!/4","doc":"Issues a PUT request to the given url, raising an exception in case of\nfailure.\n\nIf the request does not fail, the response is returned.\n\nSee `request!/5` for more detailed information.","ref":"Calendarific.HttpClient.html#put!/4"},{"type":"function","title":"Calendarific.HttpClient.request/1","doc":"Issues an HTTP request using a `Request` struct.\n\nThis function returns `{:ok, response}`, `{:ok, async_response}`, or `{:ok, maybe_redirect}`\nif the request is successful, `{:error, reason}` otherwise.","ref":"Calendarific.HttpClient.html#request/1"},{"type":"function","title":"Redirect handling - Calendarific.HttpClient.request/1","doc":"If the option `:follow_redirect` is given, HTTP redirects are automatically follow if\nthe method is set to `:get` or `:head` and the response's `status_code` is `301`, `302` or\n`307`.\n\nIf the method is set to `:post`, then the only `status_code` that get's automatically\nfollowed is `303`.\n\nIf any other method or `status_code` is returned, then this function returns a\nreturns a `{:ok, %HTTPoison.MaybeRedirect{}}` containing the `redirect_url` for you to\nre-request with the method set to `:get`.","ref":"Calendarific.HttpClient.html#request/1-redirect-handling"},{"type":"function","title":"Examples - Calendarific.HttpClient.request/1","doc":"request = %HTTPoison.Request{\n      method: :post,\n      url: \"https://my.website.com\",\n      body: \"{\\\"foo\\\": 3}\",\n      headers: [{\"Accept\", \"application/json\"}]\n    }\n\n    request(request)","ref":"Calendarific.HttpClient.html#request/1-examples"},{"type":"function","title":"Calendarific.HttpClient.request/3","doc":"","ref":"Calendarific.HttpClient.html#request/3"},{"type":"function","title":"Calendarific.HttpClient.request/5","doc":"Issues an HTTP request with the given method to the given url.\n\nThis function is usually used indirectly by `get/3`, `post/4`, `put/4`, etc\n\nArgs:\n  * `method` - HTTP method as an atom (`:get`, `:head`, `:post`, `:put`,\n    `:delete`, etc.)\n  * `url` - target url as a binary string or char list\n  * `body` - request body. See more below\n  * `headers` - HTTP headers as an orddict (e.g., `[{\"Accept\", \"application/json\"}]`)\n  * `options` - Keyword list of options\n\nBody: see type `HTTPoison.Request`\n\nOptions: see type `HTTPoison.Request`\n\nThis function returns `{:ok, response}`, `{:ok, async_response}`, or `{:ok, maybe_redirect}`\nif the request is successful, `{:error, reason}` otherwise.","ref":"Calendarific.HttpClient.html#request/5"},{"type":"function","title":"Redirect handling - Calendarific.HttpClient.request/5","doc":"If the option `:follow_redirect` is given, HTTP redirects are automatically follow if\nthe method is set to `:get` or `:head` and the response's `status_code` is `301`, `302` or\n`307`.\n\nIf the method is set to `:post`, then the only `status_code` that get's automatically\nfollowed is `303`.\n\nIf any other method or `status_code` is returned, then this function returns a\nreturns a `{:ok, %HTTPoison.MaybeRedirect{}}` containing the `redirect_url` for you to\nre-request with the method set to `:get`.","ref":"Calendarific.HttpClient.html#request/5-redirect-handling"},{"type":"function","title":"Examples - Calendarific.HttpClient.request/5","doc":"request(:post, \"https://my.website.com\", \"{\\\"foo\\\": 3}\", [{\"Accept\", \"application/json\"}])","ref":"Calendarific.HttpClient.html#request/5-examples"},{"type":"function","title":"Calendarific.HttpClient.request!/5","doc":"Issues an HTTP request with the given method to the given url, raising an\nexception in case of failure.\n\n`request!/5` works exactly like `request/5` but it returns just the\nresponse in case of a successful request, raising an exception in case the\nrequest fails.","ref":"Calendarific.HttpClient.html#request!/5"},{"type":"function","title":"Calendarific.HttpClient.start/0","doc":"Starts HTTPoison and its dependencies.","ref":"Calendarific.HttpClient.html#start/0"},{"type":"function","title":"Calendarific.HttpClient.stream_next/1","doc":"Requests the next message to be streamed for a given `HTTPoison.AsyncResponse`.\n\nSee `request!/5` for more detailed information.","ref":"Calendarific.HttpClient.html#stream_next/1"},{"type":"type","title":"Calendarific.HttpClient.body/0","doc":"","ref":"Calendarific.HttpClient.html#t:body/0"},{"type":"type","title":"Calendarific.HttpClient.headers/0","doc":"","ref":"Calendarific.HttpClient.html#t:headers/0"},{"type":"type","title":"Calendarific.HttpClient.method/0","doc":"","ref":"Calendarific.HttpClient.html#t:method/0"},{"type":"type","title":"Calendarific.HttpClient.options/0","doc":"","ref":"Calendarific.HttpClient.html#t:options/0"},{"type":"type","title":"Calendarific.HttpClient.params/0","doc":"","ref":"Calendarific.HttpClient.html#t:params/0"},{"type":"type","title":"Calendarific.HttpClient.request/0","doc":"","ref":"Calendarific.HttpClient.html#t:request/0"},{"type":"type","title":"Calendarific.HttpClient.url/0","doc":"","ref":"Calendarific.HttpClient.html#t:url/0"},{"type":"module","title":"Calendarific.Types","doc":"","ref":"Calendarific.Types.html"},{"type":"module","title":"Calendarific.Types.Country","doc":"","ref":"Calendarific.Types.Country.html"},{"type":"type","title":"Calendarific.Types.Country.country/0","doc":"","ref":"Calendarific.Types.Country.html#t:country/0"},{"type":"module","title":"Calendarific.Types.Date","doc":"","ref":"Calendarific.Types.Date.html"},{"type":"type","title":"Calendarific.Types.Date.date/0","doc":"","ref":"Calendarific.Types.Date.html#t:date/0"},{"type":"module","title":"Calendarific.Types.DateTime","doc":"","ref":"Calendarific.Types.DateTime.html"},{"type":"type","title":"Calendarific.Types.DateTime.datetime/0","doc":"","ref":"Calendarific.Types.DateTime.html#t:datetime/0"},{"type":"module","title":"Calendarific.Types.Holiday","doc":"","ref":"Calendarific.Types.Holiday.html"},{"type":"type","title":"Calendarific.Types.Holiday.holiday/0","doc":"","ref":"Calendarific.Types.Holiday.html#t:holiday/0"},{"type":"module","title":"Calendarific.Types.State","doc":"","ref":"Calendarific.Types.State.html"},{"type":"type","title":"Calendarific.Types.State.state/0","doc":"","ref":"Calendarific.Types.State.html#t:state/0"},{"type":"extras","title":"Calendarific for Elixir","doc":"# Calendarific for Elixir [![Hex pm](https://img.shields.io/hexpm/v/calendarific.svg?style=flat)](https://hex.pm/packages/calendarific) [![hex.pm downloads](https://img.shields.io/hexpm/dt/calendarific.svg?style=flat)](https://hex.pm/packages/calendarific)\n\nAn Elixir wrapper for the holiday API Calendarific (https://calendarific.com/)\n\n# Installation\n\nThis package can be installed by adding `calendarific` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:calendarific, \"~> 0.1.2\"}\n  ]\nend\n```\n\n# Configuration\n\nTo make calls to Calendarific, it is necessary to configure your Calendarific API Key on your `config.exs` file:\n\n```elixir\nconfig :calendarific, api_key: System.get_env(\"CALENDARIFIC_API_KEY\")\n# OR\nconfig :calendarific, api_key: \"YOUR API KEY\"\n```\n\n# Examples","ref":"readme.html"},{"type":"extras","title":"Holidays - Calendarific for Elixir","doc":"To fetch holidays for a given country and year, you can use the `holidays/2` method:\n\n```elixir\niex> Calendarific.holidays(country: \"US\", year: 2021)\n[\n  %Calendarific.Types.Holiday{\n    country: %Calendarific.Types.Country{id: \"us\", name: \"United States\"},\n    date: %Calendarific.Types.Date{\n      datetime: %Calendarific.Types.DateTime{day: 1, month: 1, year: 2021},\n      iso: \"2021-01-01\"\n    },\n    description: \"New Year's Day is the first day of the Gregorian calendar, which is widely used in many countries such as the USA.\",\n    locations: \"All\",\n    name: \"New Year's Day\",\n    states: \"All\",\n    type: [\"National holiday\"]\n  },\n  ...\n]\n```\n\n# Documentation\n\nThe docs can be found at [https://hexdocs.pm/calendarific](https://hexdocs.pm/calendarific).\n\n# License\n\nMore info at [LICENSE](LICENSE).","ref":"readme.html#holidays"}],"content_type":"text/markdown"}